stages:
- publish

variables:
  GIT_SUBMODULE_STRATEGY: recursive

pages:
  image: registry.gitlab.com/pages/hugo/hugo_extended:latest
  stage: publish
  variables:
    THEME: book
    DISABLE_PATH_TO_LOWER: 'true'
    ENABLE_GIT_INFO: 'true'
    MARKUP_GOLDMARK_RENDERER_UNSAFE: 'true'
    MARKUP_TABLE_OF_CONTENTS_STARTLEVEL: 2
    BOOK_EDIT_PATH: '/-/edit/main'
  before_script:
  - |
    echo "Create HUGO Book Configuration from GitLab CI vars"
    echo "=================================================="
    echo "baseURL = \"$CI_PAGES_URL\"" > config.toml
    echo "title = \"$CI_PROJECT_TITLE\"" >> config.toml
    echo "theme = \"$THEME\"" >> config.toml
  - |
    echo "disablePathToLower = $DISABLE_PATH_TO_LOWER" >> config.toml"
    echo "enableGitInfo = $ENABLE_GIT_INFO" >> config.toml"
  - |
    echo "[markup]" >> config.toml
    echo "[markup.goldmark.renderer]" >> config.toml
    echo "  unsafe = $MARKUP_GOLDMARK_RENDERER_UNSAFE" >> config.toml
    echo "[markup.tableOfContents]" >> config.toml
    echo "  startLevel = $MARKUP_TABLE_OF_CONTENTS_STARTLEVEL" >> config.toml
  - |
    echo "[params]" >> config.toml
    echo "  BookLogo = 'logo.png'" >> config.toml
    echo "  BookRepo = '$CI_PROJECT_URL'" >> config.toml
    echo "  BookEditPath = '$BOOK_EDIT_PATH'" >> config.toml
  - cat config.toml
  script:
  - hugo
  artifacts:
    paths:
    - public
  only:
  - web
  - tag
